## samba 4.3.11%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -31,6 +31,14 @@
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 WAF += -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 endif
+
+ctdb_conf_args = \
+		--prefix=/usr \
+		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
+		--sysconfdir=/etc \
+		--localstatedir=/var \
+		--with-socketpath=/var/run/ctdb/ctdbd.socket \
+		--with-logdir=/var/log/ctdb \
 
 conf_args = \
 		--prefix=/usr \
@@ -46,7 +54,7 @@
 		--with-utmp \
 		--with-pam_smbpass \
 		--with-winbind \
-		--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,vfs_dfs_samba4,auth_samba4 \
+		--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,idmap_tdb2,vfs_dfs_samba4,auth_samba4 \
 		--with-automount \
 		--with-ldap \
 		--with-ads \
@@ -62,31 +70,52 @@
 		--disable-rpath-install \
 		--bundled-libraries=NONE,pytevent,iniparser,roken,wind,hx509,asn1,heimbase,hcrypto,krb5,gssapi,heimntlm,hdb,kdc,com_err,compile_et,asn1_compile \
 		--builtin-libraries=replace,ccan,samba-cluster-support \
-		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)"
+		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
+		--with-cluster-support
 
 %:
-	dh $* --with python2
+	dh $* --with python2 --with systemd
 
 override_dh_auto_configure:
+	cd ctdb; $(shell dpkg-buildflags --export=configure) ./configure $(ctdb_conf_args)
 	$(shell dpkg-buildflags --export=configure) $(WAF) configure \
 		$(conf_args)
 
 override_dh_auto_clean:
 	-$(WAF) clean
+	dh_auto_clean --sourcedirectory=ctdb
 	find . -name "*.pyc" | xargs rm -f
 	rm -rf buildtools/bin/.waf-*
 	rm -rf bin
 	rm -f .lock-wscript
 
 override_dh_auto_install:
+	dh_auto_install --sourcedirectory=ctdb
 	DESTDIR="$(DESTDIR)" $(WAF) install
 
 override_dh_auto_build:
+	dh_auto_build --sourcedirectory=ctdb
 	ulimit -s unlimited; DESTDIR="$(DESTDIR)" $(WAF)
 
 override_dh_auto_test:
 	# Running make test requires configuration with --enable-selftest, which
 	# we don't want to do for production systems.
+
+override_dh_systemd_start:
+	dh_systemd_start -pctdb --no-start --no-restart-on-upgrade
+
+override_dh_installdocs:
+	cp ctdb/config/events.d/README ctdb/README.eventscripts
+	cp ctdb/config/notify.d.README ctdb/README.notify.d
+	dh_installdocs
+ifeq ($(DEB_BUILD_ARCH_OS), hurd)
+	dh_installdocs -pctdb debian/ctdb.README.hurd
+endif
+ifeq ($(DEB_BUILD_ARCH_OS), kfreebsd)
+	dh_installdocs -pctdb debian/ctdb.README.kfreebsd
+endif
+	#patch doc
+	sed -i 's|/etc/sysconfig/|/etc/default/|' $(CURDIR)/debian/ctdb/usr/share/doc/ctdb/web/*.html
 
 override_dh_install:
 	# get list of files in build log
@@ -101,7 +130,6 @@
 	ln -sf ../../../samba/ldb $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb/samba
 	# pam stuff
 	mkdir -p $(DESTDIR)/usr/share/pam-configs
-	install -m 0644 debian/libpam-smbpass.pam-config $(DESTDIR)/usr/share/pam-configs/smbpasswd-migrate
 	install -m 0644 debian/winbind.pam-config $(DESTDIR)/usr/share/pam-configs/winbind
 	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libnss_* $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/
 	# we don't ship the symlinks
@@ -140,6 +168,21 @@
 	   cp docs/manpages/smb.conf.5 $(DESTDIR)/usr/share/man/man5/smb.conf.5
 	# Tests that shouldn't be installed
 	rm -f $(DESTDIR)/usr/bin/async_connect_send_test
+	# Remove ctdb dev files
+	rm $(DESTDIR)/usr/include/samba-4.0/ctdb*.h
+	rm $(DESTDIR)/usr/include/ctdb*.h
+	rm $(DESTDIR)/usr/lib/*/pkgconfig/ctdb.pc
+	# Remove ctdb tests
+	rm $(DESTDIR)/usr/bin/ctdb_run_tests
+	rm $(DESTDIR)/usr/bin/ctdb_run_cluster_tests
+	rm -rf $(DESTDIR)/usr/lib/*/ctdb-tests
+	rm -rf $(DESTDIR)/usr/share/ctdb-tests
+	# Remove libpam-smbpass, which is broken and slated for removal upstream.
+	rm -f $(DESTDIR)/lib/*/security/pam_smbpass.so
+	rm -f $(DESTDIR)/usr/bin/async_connect_send_test
+	# Install ctdb conffiles
+	mkdir -p $(DESTDIR)/lib/systemd/system/
+	install -m 0644 ctdb/config/ctdb.service $(DESTDIR)/lib/systemd/system/
 	dh_install --sourcedir=$(DESTDIR) --list-missing --fail-missing
 
 override_dh_python2:
@@ -152,46 +195,6 @@
 	./debian/build-orig.sh
 
 override_dh_installchangelogs:
-	dh_installchangelogs -Nlibpam-smbpass
-ifneq (,$(filter libpam-smbpass, $(shell dh_listpackages)))
-	dh_installchangelogs -plibpam-smbpass source3/pam_smbpass/CHANGELOG
-endif
+	dh_installchangelogs
 
 override_dh_installinit:
-ifneq (,$(filter samba, $(shell dh_listpackages)))
-	dh_installinit -psamba --name smbd
-	dh_installinit -psamba --name nmbd
-	dh_installinit -psamba --name samba-ad-dc
-	dh_installinit -psamba --noscripts
-	dh_installinit -psamba --no-start --name reload-smbd
-endif
-ifneq (,$(filter winbind, $(shell dh_listpackages)))
-	dh_installinit -pwinbind
-endif
-
-override_dh_shlibdeps:
-	LD_LIBRARY_PATH=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/samba:$$LD_LIBRARY_PATH dh_shlibdeps -a
-
-override_dh_gencontrol:
-	dh_gencontrol -- -Vldb:Depends=$(LDB_DEPENDS)
-
-override_dh_makeshlibs:
-	# create symbols and shlibs files in separate wrapper script to deal with
-	# private libraries
-	debian/make_shlibs
-
-override_dh_strip:
-	# add debug symbols for all samba packages to the same debug package
-	dh_strip -a --dbg-package=samba-dbg
-
-override_dh_fixperms:
-	dh_fixperms
-ifneq (,$(filter samba-common, $(shell dh_listpackages)))
-	chmod a+x debian/samba-common/usr/share/samba/panic-action
-	# Set some reasonable default perms for the samba logdir.
-	chmod 0750 debian/samba-common/var/log/samba/
-	chown root:adm debian/samba-common/var/log/samba/
-endif
-ifneq (,$(filter samba, $(shell dh_listpackages)))
-	chmod 1777 debian/samba/var/spool/samba/
-endif
